new;

/*********************************************************************************************
***          This program was written by Sokbae Lee                                       ****
*********************************************************************************************/

n_all = 1747;
d_all = 23;

et = hsec;

/********************
*** Loading Data ****
********************/


load data[n_all,d_all] = datab.asc;

    caseid = data[.,1];
     state = data[.,2];
      wage = data[.,3];
        ex = data[.,4];
       ex2 = data[.,5];
     cafqt = data[.,6];
      mhgc = data[.,7];
       d57 = data[.,8];
       d58 = data[.,9];
       d59 = data[.,10];
       d60 = data[.,11];
       d61 = data[.,12];
       d62 = data[.,13];
       d63 = data[.,14];
    lwage5 = data[.,15];
    lurate = data[.,16];
      pub4 = data[.,17];
 lwage5_17 = data[.,18];
 lurate_17 = data[.,19];
 lavlocwage17 = data[.,20];
 avurate = data[.,21];
tuit4 = data[.,22];
 phat = data[.,23];

         y = wage;
         d = state;
    cafqt2 = cafqt.*cafqt;
  mhgc2 = mhgc.*mhgc;
lavlocwage172 = lavlocwage17.*lavlocwage17;
avurate2 = avurate.*avurate;

      xvar = ex~ex2~lwage5~lurate~cafqt~mhgc~cafqt2~mhgc2~lavlocwage17~avurate~lavlocwage172~avurate2;
      zvar = pub4~lwage5_17~lurate_17~tuit4;
  data_all = y~d~xvar~zvar;

     data1 = packr(data_all);  @ remove missing values @

         n = rows(data1);
        dd = cols(data1);

/**************************
*** Summary Statistics ****
**************************/

  sum_data = y~d~xvar~zvar;

m_spec = 2; @ choose a model @

if m_spec == 1;
/*****************************************************************************************
*** Specification I : Separable between ex and other variables and linear instruments ****
*****************************************************************************************/

  expan_x1 = 1;   @ quadratic @
  inter_x1 = 0;   @ no interactions @
  expan_x2 = 1;   @ quatratic @
  inter_x2 = 0;   @ interactions @
   expan_z = 1;   @ quatratic @
   inter_z = 0;   @ interactions @
    
        x1 = ftn_mu(xvar[.,1],expan_x1,inter_x1);             @ ex and ex^2 @                         
        x2 = ftn_mu(xvar[.,2:cols(xvar)],expan_x2,inter_x2);  @ afqt and other variables: quadratic expansion including linear interactions @                                    
         x = x1~x2;                                           @ separability between x1 and x2 @   

       dx1 = grad_mu(xvar[.,1],expan_x1,inter_x1,ones(n,1));                    @ gradient w.r.t. x1 @                                    
       dx2 = grad_mu(xvar[.,2:cols(xvar)],expan_x2,inter_x2,ones(n,1));         @ gradient w.r.t. x2 @

   mean_dx = dx1~zeros(rows(dx1),cols(dx2))|zeros(rows(dx2),cols(dx1))~dx2;

     xbar1 = ftn_mu(meanc(xvar[.,1])',expan_x1,inter_x1);                                      
     xbar2 = ftn_mu(meanc(xvar[.,2:cols(xvar)])',expan_x2,inter_x2);                                         
      xbar = (xbar1~xbar2)';
 
         z = ftn_mu(zvar,expan_z,inter_z);                  @ instruments: linear expansion @                


elseif m_spec == 2;
/******************************************************************************************************************
*** Specification II : Interactions between ex and other variables and quadratic instruments with interactions ****
******************************************************************************************************************/

   expan_x = 1;   @ quatratic @
   inter_x = 0;   @ interactions @
   expan_z = 1;   @ quatratic @
   inter_z = 0;   @ interactions @
    
   
         x = ftn_mu(xvar,expan_x,inter_x);                                     
   mean_dx = grad_mu(xvar,expan_x,inter_x,ones(n,1));                                    
      xbar = ftn_mu(meanc(xvar)',expan_x,inter_x)';                                      
         z = ftn_mu(zvar,expan_z,inter_z);                              

endif;
      
   
/**********************************
*****  Collecting variables *******
**********************************/

     data1 = y~d~x~z;
         n = rows(data1);
        dd = cols(data1);
        
ps = data[.,23];


/*** trimming function ***/

/*  psind = ones(rows(ps),1);      no trimming */

 psind = (ps.>=0).*(ps.<=1); 

/*

/**********************************************************
*****  Cross Validation (Polynomial Approximation)  *******
**********************************************************/

/*** D = 1 ***/

 data01 = selif(data1~ps,d);
    y01 = data01[.,1];
    d01 = data01[.,2];
   xz01 = data01[.,3:dd];
    x01 = xz01[.,1:cols(x)];
    z01 = xz01[.,(dd-2-cols(z)+1):(dd-2)];
   ps01 = data01[.,cols(data01)];    
   
bdwmat = 0|1|2|3|4|5;
 cvmat = {};

j = 1;
do until j > rows(bdwmat);

  basis = 1|bdwmat[j];
     cv = cv_ser(y01,x01,ps01,basis); 
  cvmat = cvmat|cv;

" basis -- cv " basis[2]~cv;
j = j + 1;
endo;

b_opt_1 = 1|bdwmat[minindc(cvmat)];

output on;
" Polynomial Approximation ";
" D=1: optimal basis " b_opt_1';
output off;

/*** D = 0 ***/

 data00 = selif(data1~ps,(1-d));

    y00 = data00[.,1];
    d00 = data00[.,2];
   xz00 = data00[.,3:dd];
    x00 = xz00[.,1:cols(x)];
    z00 = xz00[.,(dd-2-cols(z)+1):(dd-2)];
   ps00 = data00[.,cols(data01)];    
   
bdwmat = 0|1|2|3|4|5;
 cvmat = {};

j = 1;
do until j > rows(bdwmat);

  basis = 1|bdwmat[j];
     cv = cv_ser(y00,x00,ps00,basis);
  cvmat = cvmat|cv;

" basis -- cv " basis[2]~cv;
j = j + 1;
endo;

b_opt_0 = 1|bdwmat[minindc(cvmat)];

output on;
" D=0: optimal basis " b_opt_0';
output off;

*/


/**************************************
*** Estimation of E(Y|P) ***
**************************************/

/****************************
*** Series Approximation ****
****************************/

b_01 = 1|2@(b_opt_1[2]+1)@;

{fps, dfps} = serapp(ps,b_01);


/*** trimming function ***/

 psind = (ps.>=0.05).*(ps.<=0.98); 

/****************************/

trim_wgt = 0.02;  @ Proportion of trimming of data for Robinson's estimator @ 
bdw_beta = 0.05;  @ Bandwidth for Robinson's estimator @ 

h_b01 = bdw_beta;

 data01 = selif(data1~fps~dfps,psind);

    y01 = data01[.,1];
    d01 = data01[.,2];
   xz01 = data01[.,3:dd];
    x01 = xz01[.,1:cols(x)];
    z01 = xz01[.,(dd-2-cols(z)+1):(dd-2)];
  fps01 = data01[.,(dd+1):(dd+cols(fps))];
 dfps01 = data01[.,(dd+cols(fps)+1):(dd+cols(fps01)+cols(dfps))];  
   ps01 = fps01[.,2];
  reg01 = (x01.*ps01)~x01;

 bhat01 = plr(y01,reg01,ps01,h_b01,trim_wgt);
 beta01p = bhat01[1:cols(x01)];
 beta01 = bhat01[cols(x01)+1:2*cols(x01)];
    u01 = y01 - x01*beta01 - (x01.*ps01)*beta01p;

output file = beta.out reset;
output off;

format /rd /m1 12,3;

output on;
beta01;
output off;

output file = betap.out reset;
output off;

format /rd /m1 12,3;

output on;
beta01p;
output off;

/*******************************************************************************
*** Estimation of the First Components of the Conditional Means of Log Wages ***
*******************************************************************************/

     xb01 = xbar'beta01;
     xb01p = xbar'beta01p;

   /******************************************************
   ** Bandwidth Selection by Residual Squares Criterion **
   ******************************************************/

ps_range = 0.05~0.95;
h01_1 = 0.05@bdwrsc(u01,ps01,ps_range,0)@;
h01_2 = 0.322@bdwrsc(u01,ps01,ps_range,1)@;

output file = bw.out reset;
output off;

format /rd /m1 12,3;
output on;
"bandwidth" h01_1 h01_2;
output off;

/**************************************************************************************
*** Estimation of the Conditional Means of Disturbance Terms of Outcome Equations   ***
***************************************************************************************/

v0 = seqa(0,0.04,26);
@v0 = ps01;@

ci_level = 0.05;
ci_level = 1 - ci_level/2;

/*** Outcome Equation ***/

   r_1 = {};
 var_1 = {};

 hstar01 = 0.260 @0.310 bdwrsc(u01,ps01,ps_range,3)@;

  i = 1;

  do until i > rows(v0);

  {mh2,dmh2} = lpre(u01,ps01,v0[i],h01_2,2);

        tmp2 = dmh2;

          fh = tmp2;

         r_1 = r_1|fh;

"D=1 " i~v0[i];

   i = i + 1;
   endo;


  yr_1 = r_1;

output file = mte.out reset;
output off;

format /rd /m1 12,3;

output on;
v0~yr_1;
output off;

output file = z.out reset;
output off;

format /rd /m1 12,3;

output on;
v0;
output off;

/*********************************************************
******                 Procedures               **********
**********************************************************/

/*************************************************/
/*************** Some Utilities ******************/
/*************************************************/

proc(1) = ftn_mu(x,p,i);
/* Inputs: x n*d data
           p order of polynomials 
           i =1 if linear interactions are included; =0 otherwise 
   Output: ftn n*(d*p + no. of interaction terms) vector 
*/  
           
local n,d,ftn,j;

  n = rows(x);
  d = cols(x);

ftn = polymat(x,p);                           @ polynomial terms @

if (i == 1);

j = 1;
do until j > (d-1);

ftn = ftn~(x[.,j].*x[.,(j+1):d]);             @ interaction terms @ 

j = j + 1;
endo;

endif;

retp(ftn);
endp;

/*************************************************/

proc(1) = grad_mu(x,p,i,w);
/* Inputs: x n*d data
           p order of polynomials 
           i =1 if linear interactions are included; =0 otherwise 
           w n*1 weights
   Output:  gr d*(d*p + no. of interaction terms) mean vector   
*/                 
           
local n,d,ftn,j,dj,cdj,gr,k,ind,xj,dx,ii;

  n = rows(x);
  d = cols(x);

ftn = polymat(x,p);                           @ polynomial terms @

if (i == 1);

j = 1;
do until j > (d-1);

ftn = ftn~(x[.,j].*x[.,(j+1):d]);             @ interaction terms @
 
j = j + 1;
endo;

endif;


 gr = {};
  k = 1;
  do until k > d;
  
      dx = zeros(n,cols(ftn));                     @ gradient @
 dx[.,k] = ones(n,1);                                             

if p > 1;  

         dx[.,seqa((d+k),d,(p-1))] = (polymat(x[.,k],p-1).*seqa(2,1,p-1));   @ derivative of polynomial terms @
endif;

if (i == 1);

 dj = seqa(d-1,-1,d-1); 
cdj = 0|cumsumc(dj);

ind = setdif(seqa(1,1,d),k,1);

 xj = x[.,ind];

if (k < d);
dx[.,(d*p + cdj[k] + 1):(d*p + cdj[k] + dj[k])] = xj[.,k:(d-1)];             @ interaction terms @
endif;

ii = 1;
do while ii < k;

dx[.,(d*p + cdj[ii] + k-ii)] = xj[.,ii];  

ii = ii + 1;
endo;

endif;

gr = gr|meanc(dx.*w)';
 
 k = k + 1;
 endo;
   
 
retp(gr);
endp;


/*************************************************/
/*************** Logit Regression ****************/
/*************************************************/

proc (5) = logit(y,x);
local cnv,b0,b1,i,ind,P,grd,hes,h1,dev,OP,EOP,se1,se2,t1,t2,ps,avar;

cnv = 0;

b0 = zeros(cols(x),1); @ starting value @

i = 1;
do until cnv == 1;

ind = x*b0;
P = exp(ind)./(1+exp(ind));

grd = sumc((y - P).*x);
hes = -x'(P.*(1-P).*x);

b1 = b0 - inv(hes)*grd;

dev = maxc(abs(b1-b0));

if dev < 1e-8; @ stopping rule @
cnv = 1;
endif;

b0 = b1;

i = i + 1;
endo;

/* One could use OP instead of EOP.
 OP = ((y-P).*x)'((y-P).*x)/n; @ outer product @
se1 = sqrt(diag(invpd(OP))/n);
 t1 = b1./se1;
*/

EOP = -hes/n;  @ expected info. @
se2 = sqrt(diag(invpd(EOP))/n);
 t2 = b1./se2;

ps = exp(x*b1)./(1+exp(x*b1));

avar = invpd(EOP);

" Logit Regression: No. of iteration " i;

retp(b1,se2,t2,ps,avar);
endp;


/*****************************************************/
/*************** Series Approximation ****************/
/*****************************************************/

proc (2) = serapp(p,basis);
@
--- Inputs ---
    p = n*1 vector of data
basis = 3*1 vector of options
        if basis[1] = 1 is chosen, basis[2]-th order polynomial approximation is used.      
        if basis[1] = 2 is chosen, basis[2]-th order P-spline approximation is used with basis[3] number of knots. 
--- Output ---
  app = n*1 vector of values of an approximating function
  dap = n*1 vector of values of the derivative of an approximating function  
@


local b1, b2, app, dap, i, b3, tmp;

 b1 = basis[1];
 b2 = basis[2];
  
app = ones(rows(p),1);
dap = {};

if b1==1;         @ polynomials @

i = 1;
do until i > b2;

app = app~(p^i);
dap = dap~(i*p^(i-1));

i = i + 1;
endo;

elseif b1==2;   @ splines @ 

b3 = basis[3];

i = 1;
do until i > b2;

app = app~(p^i);
dap = dap~(i*p^(i-1));

i = i + 1;
endo;

i = 1;
do until i > b3;

tmp = p - quantile(p,(i/(b3+1)));
tmp = (tmp .> 0).*tmp;

app = app~(tmp.^b2);
dap = dap~(b2*tmp.^(b2-1)); 

i = i + 1;
endo;

endif;

retp(app,dap);
endp;




/**********************************************************/
/*************** 2nd Order Kernel Function ****************/
/**********************************************************/
proc(1) = kl(v);
local term;
retp(pdfn(v));
endp;



/*********************************************************/
/*    Local Polynomial Regression Estimator              */
/*********************************************************/

proc(2) = lpre(y,x,x0,h,p);

@
--- Inputs ---
    y = n*1 vector of dependent variable
    x = n*1 vector of observations of independent variables
   x0 = a point where a regression function is evaluated
    h = a bandwidth
    p = order of polynomials
--- Output ---
local polynomial regression estimate (evaluated at x0)
@

local n,w,z,i,arg,b,mhat,dmhat;

   n = rows(x);

 arg = (x-x0);
   w = kl(arg/h);

   z = ones(n,1);

   i = 1;
   do until i > p;

   z = z~(arg.^i);

   i = i + 1;
   endo;

   w = w + 1e-5*(w.==0);  @ This is to avoid singularity of z'w*z. @
   w = diagrv(eye(n),w);
   b = invpd(z'w*z)*(z'w*y);

 mhat = b[1];
dmhat = b[2];
retp(mhat,dmhat);
endp;


/**********************************************/
/*    Residual Squares Criterion              */
/**********************************************/

proc(1) = rsc(y,x,x0,h,v);

@
--- Inputs ---
    y = n*1 vector of dependent variable
    x = n*1 vector of observations of indepedent variable
   x0 = a point where a regression function is evaluated
    h = a bandwidth
    v = 0 for estimation of regression function
      = k for the k-th-order derivative
--- Output ---
value of RSC
@

local p,n,arg,w0,z,i,w,tmp0,tmp1,bhat,yhat,tmp2,vmat,vm,tmp3,tmp4,tmp5,sm2,rsc;

   p = v + 1;
   n = rows(x);

 arg = (x-x0);

  w0 = kl(arg/h);

   z = ones(n,1);

   i = 1;
   do until i > p;

   z = z~(arg.^i);

   i = i + 1;
   endo;

   w = w0 + 1e-5*(w0.==0);  @ This is to avoid singularity of z'w*z. @
   w = diagrv(eye(n),w);
tmp0 = z'w*y;
tmp1 = invpd(z'w*z);
bhat = tmp1*tmp0;
yhat = z*bhat;
tmp2 = z'(w^2)*z;
vmat = tmp1*tmp2*tmp1;
  vm = vmat[1,1];

tmp3 = w - w*z*tmp1*z'w;
tmp4 = sumc(diag(tmp3));          @ trace of tmp3 @
tmp4 = tmp4 + 1e-8*(tmp4.==0);
tmp5 = sumc(((y-yhat)^2).*w0);
 sm2 = tmp5/tmp4;

 rsc = sm2*(1+(p+1)*vm);

retp(rsc);

endp;


/******************************************************
** Bandwidth Selection by Residual Squares Criterion **
******************************************************/

proc(1) = bdwrsc(y,x,x_range,v);
@
--- Inputs ---
    y = n*1 vector of dependent variable
    x = n*1 vector of observations of indepedent variable
    x_range = 2*1 vector [xmin, xmax]: range where a regression function is evaluated
    v = 0 for estimation of regression function
      = k for the k-th-order derivative (maximum k is 3).
--- Output ---
optimal value of RSC
@
local xmin,xmax,dx,xseq,hmin,hmax,h_cons,rscmat,bdwmat,h_ind,k,bdw,irsc,j,h_rsc,bdw_opt;


xmin = x_range[1];
xmax = x_range[2];
  dx = (xmax-xmin)/10;
xseq = seqa(xmin,dx,11);


  hmin = (maxc(x) - minc(x))/20;
  hmax = (maxc(x) - minc(x))/2;
  h_cons = 1.1;

  rscmat = {};
  bdwmat = {};

   h_ind = 0;

k = 1;
do until (h_ind == 1);

bdw = hmin*(h_cons^k);


irsc = {};
j = 1;
do until j > rows(xseq);

  h_rsc = rsc(y,x,xseq[j],bdw,v);
   irsc = irsc|h_rsc;

j = j + 1;
endo;

irsc = sumc(irsc);

" Bandwidth -- IRSC " bdw~irsc;

rscmat = rscmat|irsc;
bdwmat = bdwmat|bdw;

h_ind = (bdw > hmax);

k = k + 1;
endo;

bdw_opt = bdwmat[minindc(rscmat)];

bdw_opt = (v==0)*bdw_opt + (v==1)*0.8403*bdw_opt + (v==2)*0.8285*bdw_opt + (v==3)*0.8085*bdw_opt;

retp(bdw_opt);
endp;


/**********************************************/
/*   Asymptotic Variance Estimation           */
/**********************************************/

proc(1) = ave(y,x,x0,h,hs,v);

@
--- Inputs ---
    y = n*1 vector of dependent variable
    x = n*1 vector of observations of independent variable
   x0 = a point where a regression function is evaluated
    h = a bandwidth that is used for estimation of the function
   hs = a pilot bandwidth
    v = 0 for estimation of regression function
      = 1 for the first-order derivative
--- Output ---
asymptotic variance estimate
@

local p,pa,n,arg,w0,z,i,w,tmp0,tmp1,bhat,yhat,tmp2,vmat,vm,tmp3,tmp4,tmp5,sm2,vc;

   p = v + 1;
  pa = p + 2;
   n = rows(x);

 arg = (x-x0);
  w0 = kl(arg/hs);
   z = ones(n,1);

   i = 1;
   do until i > pa;

   z = z~(arg.^i);

   i = i + 1;
   endo;

   w = w0 + 1e-5*(w0.==0);  @ This is to avoid singularity of z'w*z. @
   w = diagrv(eye(n),w);
tmp0 = z'w*y;
tmp1 = invpd(z'w*z);
bhat = tmp1*tmp0;
yhat = z*bhat;
tmp2 = z'(w^2)*z;
tmp3 = w - w*z*tmp1*z'w;
tmp4 = sumc(diag(tmp3));          @ trace of tmp3 @
tmp4 = tmp4 + 1e-8*(tmp4.==0);
tmp5 = sumc(((y-yhat)^2).*w0);
 sm2 = tmp5/tmp4;

 arg = (x-x0);
  w0 = kl(arg/h);
   z = ones(n,1);

   i = 1;
   do until i > p;

   z = z~(arg.^i);

   i = i + 1;
   endo;

   w = w0 + 1e-5*(w0.==0);  @ This is to avoid singularity of z'w*z. @
   w = diagrv(eye(n),w);

tmp1 = invpd(z'w*z);
tmp2 = z'(w^2)*z;
vmat = (tmp1*tmp2*tmp1)*sm2;
  vc = vmat[v+1,v+1];

retp(vc);

endp;
/*******************************************/
/**** CV Function for Series Estimation ****/
/*******************************************/
proc(1) = cv_ser(y,x,p,basis);

@
--- Inputs ---
    y = n*1 vector of dependent variable
    x = n*d vector of observations of covariates (parametric)
    p = n*1 vector of observations of a covariate (nonparametric) 
    h = 3*1 vector of options
--- Output ---
value of cv function at h
@

local n,i,temp,ei,yi,xi,fi,f,df,reg,bhat,yhat,cvh;

      n = rows(y);
{f, df} = serapp(p,basis);

temp = {};
   i = 1;
   do until i > n;

    ei = zeros(n,1);
 ei[i] = 1;
    yi = delif(y,ei);
    xi = delif(x,ei);
    fi = delif(f,ei);
    reg = xi~fi;
   bhat = invpd(reg'reg)*(reg'yi);
   yhat = (x[i,.]~f[i,.])*bhat;

  temp = temp|yhat;

   i = i + 1;
   endo;

    cvh = meanc((y-temp)^2);
 
retp(cvh);
endp;
   /*********************************************************/
   /*             Kernel Estimator                          */
   /*********************************************************/

proc(1) = nwk(y,x,x_arg,h);

@
--- Inputs ---
    y = n*1 vector of dependent variable
    x = n*d vector of observations of independent variables
x_arg = k*d vector of arguments of regression function
    h = d*1 vector of bandwidths
--- Output ---
k*1 vector of kernel estimates
@

local n,d,k,i,arg,tmp1,tmp2,m,mhat;

   n = rows(x);
   d = cols(x);
   k = rows(x_arg);

tmp1 = ones(k,n);
   i = 1;
   do until i > d;

          arg = (x_arg[.,i]-x[.,i]')/h[i];
         tmp1 = tmp1.*kl(arg);

   i = i + 1;
   endo;

   m = y';
tmp2 = tmp1.*m;
mhat = sumc(tmp2')./(1e-8 + sumc(tmp1'));

retp(mhat);
endp;

/**********************************************************/
/*************** Kernel Density Estimator *****************/
/**********************************************************/
proc(1) = kde(x,x_arg,h);

@
--- Inputs ---
    x = n*d vector of observations
x_arg = k*d vector of arguments of density
    h = d*1 vector of bandwidths
--- Output ---
k*1 vector of kernel density estimates
@

local n,d,k,i,arg,tmp,fhat;

   n = rows(x);
   d = cols(x);
   k = rows(x_arg);

 tmp = ones(k,n);
   i = 1;
   do until i > d;

          arg = (x_arg[.,i]-x[.,i]')/h[i];
          tmp = tmp.*(kl(arg)/h[i]);

   i = i + 1;
   endo;

fhat = meanc(tmp');

retp(fhat);
endp;



   /*********************************************************/
   /*             Partially Linear Regression               */
   /*********************************************************/

proc(1) = plr(y,x,w,h,trim_wgt);
@
--- Inputs ---
    y = n*1   vector of obs. of the dependent variable
    x = n*d_x vector of obs. of the parametric part of explanatory variables
    w = n*d_w vector of obs. of the nonparametric part of explanatory variables
    h = d_w*1 vector of bandwidths
    trim_wgt = percentage of trimming of the data (between 0 and 1)
               no trimming if trim_wgt == 0
--- Output ---
d_w*1 vector of parameter estimates
@

local dx, yhat, xhat, j, fhat, fh, ev, wgt, s_xx, s_xy, bhat;
/* Estimation of Yhat and Xhat */

  dx = cols(x); 
yhat = nwk(y,w,w,h);

xhat = {};
j = 1;
do until j > dx;

xhat = xhat~nwk(x[.,j],w,w,h);

j = j + 1;
endo;

/* Trimming */ 

if trim_wgt > 0;

   fhat = kde(w,w,h);             @ kernel density esitimate @
     fh = sortc(fhat,1);
     ev = fh[round(n*trim_wgt)];  @ about (trim_wgt)% of the obs. with the smallest density estimate @
    wgt = (fhat .> ev);           @ weight function @

elseif trim_wgt == 0;

    wgt = ones(rows(w),1);        @ no trimming @
    
endif;    
      
/*  Estimation of beta  */

s_xx = ((x-xhat).*wgt)'(x-xhat)/n;
s_xy = ((x-xhat).*wgt)'(y-yhat)/n;

bhat = invpd(s_xx)*s_xy;

retp(bhat);

endp;
