function[m]=kerndens(x,dom,h)
%[m]=kernreg(y,x,dom,h)
%Take a model of the form y=m(x)+e where y,x and e are n by 1 vectors
%x is continuous with density f(x) and e is iid and homoscedastic
%This function calculates the nonparametric regression using different
%kernel functions (specified by user). 
%OPTIONS:
%	h:
%		defines the width of the weight function window around each grid 
%		point
%	weight:
%		OPTIONAL, if you have a n by 1 frequency weighting vector for the 
%		variables (of the kind used when working with surveys also known as
%		as an expansion factor).
%	m: 
%		is the name for the conditional mean vector m(x)
%	dom:
%		is the name of the domain x
n=size(x,1);
nn=size(dom,1);
fid=fopen('temp.txt','w');
for s=1:nn;
   for i=1:n;
      k(i,1)=exp((-((dom(s,1)-x(i,1))/h)^2)/2)/sqrt(2*pi);
   end;
   a=sum(k);   
   m(s,1)=a/(h*n);
end;
%figure;
%plot(dom,m);